/***
* Copyright (C) 1999 Gary Pennington, Robert W. Watson
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The authors can be contacted via email at Gary.Pennington@uk.sun.com
* and Robert.W.Watson@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the program `jProf' (a program for profiling Java programs) written
* by Gary Pennington and Rob Watson.
***/
/***
*
*  Description
*
*  SCCS: ChartParser.java @(#)ChartParser.java	1.1 06/09/99 
*
***/
package jProf;
import java.io.*;
import java.util.*;

import org.w3c.dom.*;
import org.xml.sax.*;
import org.xml.sax.helpers.ParserFactory;
import org.xml.sax.helpers.AttributeListImpl;

import com.sun.xml.parser.Resolver;

public class ChartParser
{

 private Vector    elements =new Vector();
 private Vector    elementList=new Vector();
 Hashtable  hash=new Hashtable();
 String     start,end;
     
    public static void main(String argv[])
    {
  ChartParser CP=new ChartParser(argv[0]);
    }
    
    
   public ChartParser(String fileName)
   {
  InputSource  input;
     Parser    parser;    
      
      this.elementList=elementList;
      try
      { 
         input = Resolver.createInputSource (new File (fileName+".xml"));
         parser = ParserFactory.makeParser ();
     parser.setDocumentHandler (new innerParser (this));
     parser.setErrorHandler (new MyErrorHandler ());
     parser.parse (input);
  }catch(SAXParseException err){
    System.out.println(err.getMessage());
    System.exit(1);
  } catch (SAXException e) {
    System.out.println(e.getMessage());
    System.exit(1);
  } catch (Throwable t) {
      t.printStackTrace ();
  }
  
   }
   
   public ChartParser(String fileName, String s)
   {
  InputSource  input;
     Parser    parser;    
      
      try
      { 
         input = Resolver.createInputSource (new File (fileName+".xml"));
         parser = ParserFactory.makeParser ();
     parser.setDocumentHandler (new innerParser1 (this,s));
     parser.setErrorHandler (new MyErrorHandler ());
     parser.parse (input);
  }catch(SAXParseException err){
    System.out.println(err.getMessage());
    System.exit(1);
  } catch (SAXException e) {
    System.out.println(e.getMessage());
    System.exit(1);
  } catch (Throwable t) {
      t.printStackTrace ();
  }
  
   }
   
   public Vector getElements()
   {
      return elements;  
   }
   
   
   static class MyErrorHandler extends HandlerBase
    {
  // treat validation errors as fatal
  public void error (SAXParseException e)
  throws SAXParseException
  {
      throw e;
  }

  // dump warnings too
  public void warning (SAXParseException err)
  throws SAXParseException
  {
      System.out.println ("** Warning" 
    + ", line " + err.getLineNumber ()
    + ", uri " + err.getSystemId ());
      System.out.println("   " + err.getMessage ());
  }
    }
    
   static class innerParser implements DocumentHandler
   {
   
     ChartParser cpm;
     
     public innerParser(ChartParser cp)
     {
       cpm=cp;
     }
   
     Vector elements=new Vector();
     
     public void startDocument () throws SAXException
  {}
      
  public void endDocument () throws SAXException
  {
  }

     public void startElement (String tag, AttributeList attrs) throws SAXException
      {
        String temp;
        if(tag == "header")
        {
          cpm.start=attrs.getValue("start");
        }
        if(tag == "trailer")
        {
        
          cpm.end=attrs.getValue("end");
        }
      }
      
      private String getField(String tag, AttributeList attrs,String type,String field) throws SAXException
      {
        if(0==tag.compareTo(type))
        {
          return attrs.getValue(field);    
        }else{
          return null;  
        }
      }

      public void endElement (String name) throws SAXException
        {
          if(!cpm.elements.contains(name))
          {
            cpm.elements.add(name);
          }
      
        }
        
      public void characters (char buf [], int offset, int len) throws SAXException
      {}

     public void ignorableWhitespace (char buf [], int offset, int len) throws SAXException
      {}

        public void processingInstruction (String target, String data) throws SAXException
      {}
    
      public void setDocumentLocator (Locator l)
      {}

   }
   
      static class innerParser1 implements DocumentHandler
   {
     ChartParser cpm;
     String elementToCollect = new String();
     
     public innerParser1(ChartParser cp, String s)
     {
       cpm=cp;
       elementToCollect = s;
       cpm.elements.removeAllElements();
     }
     
     public void startDocument () throws SAXException
  {}
      
  public void endDocument () throws SAXException
  {
      
  }

     public void startElement (String tag, AttributeList attrs) throws SAXException
      {
  
        if(elementToCollect == tag)
        {
          cpm.elements.addElement(new AttributeListImpl(attrs));  
        }
      }
      
      private String getField(String tag, AttributeList attrs,String type,String field) throws SAXException
      {
        if(0==tag.compareTo(type))
        {
          return attrs.getValue(field);    
        }else{
          return null;  
        }
      }

      public void endElement (String name) throws SAXException
        {}

      public void characters (char buf [], int offset, int len) throws SAXException
      {}

     public void ignorableWhitespace (char buf [], int offset, int len) throws SAXException
      {}

        public void processingInstruction (String target, String data) throws SAXException
      {}
    
      public void setDocumentLocator (Locator l)
      {}

   }

}
