/***
* Copyright (C) 1999 Gary Pennington, Robert W. Watson
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The authors can be contacted via email at Gary.Pennington@uk.sun.com
* and Robert.W.Watson@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the program `jProf' (a program for profiling Java programs) written
* by Gary Pennington and Rob Watson.
***/
/***
*
*  Description
*
*  SCCS: ControlFileReader.java @(#)ControlFileReader.java	1.1 06/09/99 
*
***/
package jProf;
import java.io.*;

public class ControlFileReader 
{

  RandomAccessFile fr;
  
  public ControlFileReader(String fileName)
  {
    try{
      fr =new RandomAccessFile(fileName,"r");
    }catch(Exception e){
      System.out.println("Could not open file "+fileName+" because:");
      System.out.println(e.getMessage());
      System.exit(-1);
    }
  }
  
  public String getNextCommand()
  {
    try{
      return(fr.readLine());
    }catch(Exception e){
      System.out.println("Could not read file because:");
      System.out.println(e.getMessage());
      System.exit(-1);
    }
    return(null);
  }
}
