/***
* Copyright (C) 1999 Gary Pennington, Robert W. Watson
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The authors can be contacted via email at Gary.Pennington@uk.sun.com
* and Robert.W.Watson@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the program `jProf' (a program for profiling Java programs) written
* by Gary Pennington and Rob Watson.
***/
/***
*
*  Description
*
*  SCCS: DataSourceTemplate.java @(#)DataSourceTemplate.java	1.1 06/09/99 
*
***/
package jProf;
import java.util.Vector;
import jclass.chart.JCChart;
import jclass.chart.ChartDataView;
import jclass.chart.FileDataSource;
import jclass.chart.EventTrigger;
import jclass.chart.*;
import jclass.util.JCString;
import jclass.chart.JCAxis.*;


class DataSourceTemplate implements Chartable, Cloneable
{
    
      // holds Data
      private Vector data= new Vector();
      
      //Holds chart name and type
      String name =new String();
      String type =new String();
      
       // number of points
      private int nPoints;
		//Default label array size
		private static final int LABEL_ARRAY_SIZE=64;
      // point labels
     private String[] pointLabel=new String[DataSourceTemplate.LABEL_ARRAY_SIZE];
      // series labels
     private String[] seriesLabel=new String[DataSourceTemplate.LABEL_ARRAY_SIZE];
     
     String xName;
     String yName;
     private int seriesLabelCtr=0;


      // constructor
      DataSourceTemplate(String name, String type)
      {
       //this.name = name;
       this.name = "Legend";
       this.type = type;                            
      }    
      
      
      public void setXName(String x)
      {
          xName =x;
      }
      
      public void setYName(String y)
      {
          yName =y;
      }
      
      public String getXName()
      {
        return xName;
      }
      
      public String getYName()
      {
        return yName;
      }
      public void setPointLabel(String s,int i)
      {
					if(i>pointLabel.length-1)
					{
							//Double Size of Buffer to accomodate
							String newSeries[]=new String[seriesLabel.length*2];
							String newPoint[]=new String[pointLabel.length*2];
							System.arraycopy(pointLabel,0,newPoint,0,pointLabel.length);
							System.arraycopy(seriesLabel,0,newSeries,0,seriesLabel.length);
							pointLabel=newPoint;
							seriesLabel=newSeries;
					}
          pointLabel[i] = s;
      }
      
     public void setXData(Vector x)
     {
        data.add(0,x);
     }
     
     public Vector getXData()
     {
       return (Vector)data.firstElement();
     }
     
     public void setYData(Vector y)
     {
        data.add(y);
     }
     
     public Vector getYData()
     {
         return (Vector)data.elementAt(1);
     }
     
     public int getNPoints()
     {
       return(nPoints);
     }
     
     public void setNPoints(int num)
     {
       nPoints=num;
     }
     
     public void setName(String name)
     {
       this.name=name;
     }
     
     public void setType(String type)
     {
       this.type=type;
     }
     
     public String getName()
     {
       return(this.name);
     }
     
     public String getType()
     {
       return(this.type);
     }
     
     public String toString()
     {
       return(this.name);
     }
     
      public Object clone()
      {
        try
        {
          DataSourceTemplate tmp=(DataSourceTemplate)super.clone();
          tmp.data=(Vector)data.clone();
          //System.arraycopy(pointLabel,0,tmp.pointLabel,0,pointLabel.length);
          //System.arraycopy(seriesLabel,0,tmp.seriesLabel,0,seriesLabel.length);
          tmp.seriesLabelCtr=0;
          return tmp;
        }
        catch(java.lang.CloneNotSupportedException cnse)
        {
          return null;
        }
      }

      public void transform()
      {
        int outerLoopCount=data.size();
        for(int i=1;i<outerLoopCount;i++)
        {
          Vector yData=(Vector)data.elementAt(i);
          data.removeElementAt(1);
          for(int j=0;j<yData.size();j++)
          {
            Vector myVector=new Vector();
            myVector.add(yData.elementAt(j));
            data.add(myVector);
          }
        }
        for(int i=0;i<pointLabel.length;i++)
        {
          seriesLabel[i]=pointLabel[i];
        }
        pointLabel=null;
      }
     //methods needed for the chartable object
     // needs to be implemented correctly later.
     
     public int getDataInterpretation()
     {
        return ARRAY;
     }
            
      public java.lang.Object getDataItem(int row,int column)
      {
          Object rval = null;
          try {
            rval = ((Vector)data.elementAt(row)).elementAt(column);
          }
          catch (Exception e) {
          }
          return rval;
       }

       public java.util.Vector getRow(int row)
       {
        Vector rval = null;
        try {
        rval = (Vector)data.elementAt(row);
        }
        catch (Exception e) {
        }
        return rval;
       }

          public int getNumRows()
          {
            if (data == null) return 0;
            return data.size();
          }

          public java.lang.String[] getPointLabels()
          {
              return pointLabel;
          }
          
          public java.lang.String getSeriesLabel(int n)
          {
            
            return seriesLabel[seriesLabelCtr++];
          }

          public java.lang.String getSeriesName(int row)
          {
               return null;
          }  
}
     
 
 

