/***
* Copyright (C) 1999 Gary Pennington, Robert W. Watson
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The authors can be contacted via email at Gary.Pennington@uk.sun.com
* and Robert.W.Watson@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the program `jProf' (a program for profiling Java programs) written
* by Gary Pennington and Rob Watson.
***/
/***
*
*  Description
*
*  SCCS: HtmlNavPanel.java @(#)HtmlNavPanel.java	1.1 06/09/99 
*
***/
package jProf;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.accessibility.*;

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import ice.iblite.Browser;
import java.awt.print.*;

public class HtmlNavPanel extends JPanel implements Printable
{
    //private Stack history=null;
    //private  HtmlPanel centerPanel;
    private Browser centerPanel=null;
    private String home=null;

  public HtmlNavPanel(String urlString)
  {
    super(new BorderLayout());
    home=urlString;
    JPanel northPanel=new JPanel();
    centerPanel=new ice.iblite.Browser();
    centerPanel.setCurrentLocation(urlString);
    JButton backButton=new JButton("Back");
    ActionListener aListener=new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
          centerPanel.goBack();
      }
    };
    backButton.addActionListener(aListener);
    JButton forwardButton=new JButton("Forward");
    aListener=new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        centerPanel.goForward();
      }
    };
    forwardButton.addActionListener(aListener);
    JButton homeButton=new JButton("Home");
    aListener=new ActionListener() {
      public void actionPerformed(ActionEvent e)
      {
        centerPanel.setCurrentLocation(home);
      }
    };
    homeButton.addActionListener(aListener);
    northPanel.add(backButton);
    northPanel.add(forwardButton);
    northPanel.add(homeButton);
    add(northPanel, BorderLayout.NORTH);
    add(centerPanel, BorderLayout.CENTER);
  }

  public int print(Graphics g, PageFormat pf, int pi) throws PrinterException
  {
    if(pi>=1)
      return Printable.NO_SUCH_PAGE;
    Graphics2D g2=(Graphics2D)g;
    g2.translate(pf.getImageableX(),pf.getImageableY());
    Font f=new Font("Monospaced", Font.PLAIN,12);
    g2.setFont(f);
    paint(g2);
    return Printable.PAGE_EXISTS;
  }

}


