/***
* Copyright (C) 1999 Gary Pennington
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
* 
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The author can be contacted via email at Gary.Pennington@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the library `jProf' (a library for profiling Java programs) written
* by Gary Pennington.
***/
/***
*
*  Description
*  See header file.
*
*  SCCS: jMethodEvent.cpp @(#)jMethodEvent.cpp	1.1 05/28/99 
*
***/

#include <fstream.h>  //Needed for definitions of streams etc...
#include <jvmpi.h>    //Needed for definitions of jobjectID etc...
#include "utility.h"  //Needed for time utilities, 
#include "jBaseRecord.h"
#include "jMethodEvent.h"


jMethodEvent::jMethodEvent(JVMPI_Event* event) : jBaseRecord(event), m_ID(event->u.method.method_id), m_CPUTime(0), m_CPUStamp(0), m_pPrev(NULL)
{
}

ostream& operator<< ( ostream& os, jMethodEvent & jME)
{
  jBaseRecord& jBR=jME;
  
  os<<"<method_call "<<jBR;
  os<<" duration=\""<<jME.getDuration();
  return os<<"\" method_id=\""<<jME.getID()<<"\"/>"<<endl;
}

void jMethodEvent::addCPUTime(jlong time)
{
  m_CPUTime+=time-m_CPUStamp;
  m_CPUStamp=time;
}

void jMethodEvent::subCPUTime(jlong time)
{
  m_CPUTime-=time;
}

void jMethodEvent::setCPUStamp(jlong time)
{
  m_CPUStamp=time;
}
