/***
* Copyright (C) 1999 Gary Pennington
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
* 
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The author can be contacted via email at Gary.Pennington@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the library `jProf' (a library for profiling Java programs) written
* by Gary Pennington.
***/
/***
*
*  Description
*  See header file.
*
*  SCCS: jMethodInvokedBy.cpp @(#)jMethodInvokedBy.cpp	1.1 05/28/99 
*
***/

#include <fstream.h>  //Needed for definitions of streams etc...
#include <jvmpi.h>    //Needed for definitions of jobjectID etc...
#ifdef WIN32
#include <windows.h>
#include <process.h>
#else
#include <strings.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#endif
#include "utility.h"  //Needed for time utilities, 
#include "hash.h"
#include "jBaseRecord.h"
#include "jInstanceRecord.h"
#include "jClassRecord.h"
#include "jGCRecord.h"
#include "jMethodEvent.h"
#include "jMethodInvokedBy.h"
#include "jMethodRecord.h"
#include "jThreadRecord.h"
#include "jProf.h"

ostream& operator<< ( ostream& os, jMethodInvokedBy & jMIB )
{
  const JVMPI_Method* pMthd=theProfiler()->getMethodByID(jMIB.getID());
  char* pBuf=getXMLSafeName(pMthd->method_name);
  os<<"<method_invoker name=\""<<theProfiler()->getClassByMethodID(jMIB.getID())->getName()<<"."<<pBuf;
  delete[] pBuf;
  return os<<"\" count=\""<<jMIB.getCount()<<"\"/>"<<endl;
}

jMethodInvokedBy::jMethodInvokedBy(const jMethodInvokedBy& rhs)
{
  m_ID=rhs.m_ID;
  m_Count=rhs.m_Count;
}

jMethodInvokedBy& jMethodInvokedBy::operator+=(jMethodInvokedBy& rhs)
{
  m_Count+=rhs.m_Count;
  return *this;
}

jMethodInvokedBy& jMethodInvokedBy::operator=(jMethodInvokedBy& rhs)
{
  if(this==&rhs)
    return *this;

  m_Count=rhs.m_Count;
  m_ID=rhs.m_ID;
  return *this;
}

