/***
* Copyright (C) 1999 Gary Pennington
* 
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
* 
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
* 
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA  02111-1307, USA.
* 
* Contact Details:
* The author can be contacted via email at Gary.Pennington@uk.sun.com
* 
* Sun Microsystems Inc., hereby disclaims all copyright interest in
* the library `jProf' (a library for profiling Java programs) written
* by Gary Pennington.
***/
/***
*
*  Description
*  This class implements services for calculating how many times a method
*  has been invoked and enough information to identify the method, ie it's id.
*
*  SCCS: jMethodInvokedBy.h @(#)jMethodInvokedBy.h	1.1 05/28/99 
*
***/

class jMethodInvokedBy
{
 private:
  unsigned long m_Count;      //Invocation count
  jmethodID m_ID;             //ID
 public:
  jMethodInvokedBy() : m_Count(0)  //Main Constructor
  {
  }
  jMethodInvokedBy(const jMethodInvokedBy& rhs);  //Copy Constructor
  friend ostream& operator<< ( ostream& os, jMethodInvokedBy& jMIB );  //Output
  void setID(jmethodID id)  //Set ID
  {
    m_ID=id;
  }
  jmethodID getID(void) const  //Get ID
  {
    return m_ID;
  }
  unsigned long getCount(void) const  //Get Invocation Count
  {
    return m_Count;
  }
  void incrementCount(void)  //Increment Invocation Count
  {
    m_Count++;
  }
  virtual jMethodInvokedBy& operator=(jMethodInvokedBy& rhs);  //Assignment
  virtual jMethodInvokedBy& operator+=(jMethodInvokedBy& rhs); //Add&Assign
};
